/*
 * YakiToApp.java
 */

package net.yakiboo.yakito;

import net.yakiboo.yakito.config.YakiToConfig;
import net.yakiboo.yakito.io.YakiToOutput;
import net.yakiboo.yakito.io.YakiToXMLSyntaxException;
import net.yakiboo.yakito.language.YakiToNoLanguagesException;
import net.yakiboo.yakito.update.YakiToUpdater;
import net.yakiboo.yakito.view.YakiToView;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;
import java.awt.Toolkit;
import java.io.File;

/**
 * Clase principal de la aplicacion. Es la clase que hay que lanzar al ejecutar
 * la aplicacion
 */
public class YakiToApp extends SingleFrameApplication {

	YakiToView gui;
	YakiToConfig config;
	YakiToUpdater updater;

	/**
	 * Inicializa los elementos visuales y la configuracion de YakiTo
	 */
	@Override
	protected void startup() {
		boolean error = false;
		try {
			config = new YakiToConfig();
			/*
			 * //TODO Terminar la parte de las actualizaciones updater = new
			 * YakiToUpdater(config); if (updater.checkUpdates()) {
			 * YakiToOutput.message("Existen actualizaciones nuevas. " +
			 * "Descargando actualizaciones..."); updater.update();// Quitar
			 * esto para que no solo se actualice // manualmente }
			 */
			gui = new YakiToView(this, config);
			gui.getFrame().setIconImage(
					Toolkit.getDefaultToolkit().getImage(
							"net/yakiboo/yakito/view/resources/favicon.png"));
			show(gui);
		} catch (YakiToNoLanguagesException ex) {
			YakiToOutput
					.error("No se han encontrado archivos de idioma. No se puede construir la interfaz.");
			this.exit();
		} catch (YakiToNoContainersException ex) {
			YakiToOutput
					.error("No se ha encontrado el archivo de contenedores multimedia. La aplicación no puede continuar.");
			this.exit();
		} catch (YakiToXMLSyntaxException ex) {
		}
	}

	/**
	 * This method is to initialize the specified window by injecting resources.
	 * Windows shown in our application come fully initialized from the GUI
	 * builder, so this additional configuration is not needed.
	 */
	@Override
	protected void configureWindow(java.awt.Window root) {

	}

	/**
	 * A convenient static getter for the application instance.
	 * 
	 * @return the instance of YakiToApp
	 */
	public static YakiToApp getApplication() {
		return Application.getInstance(YakiToApp.class);
	}

	/**
	 * Main method launching the application.
	 */
	public static void main(String[] args) {
		launch(YakiToApp.class, args);
	}
}
