package net.yakiboo.yakito;

import it.sauronsoftware.jave.Encoder;
import it.sauronsoftware.jave.EncoderException;

import java.util.LinkedList;

import net.yakiboo.yakito.io.YakiToOutput;

/**
 * Clase de utilidades para codecs multimedia de YakiTo
 * 
 * @author Sergio Garcia Mondaray
 * 
 */
public class YakiToCodec {

	/**
	 * Obtiene un listado con todos los codecs de audio disponibles
	 * 
	 * @return Lista de codecs
	 */
	public static LinkedList<String> listAvailableAudioCodecs() {
		Encoder e = new Encoder();
		LinkedList<String> list = new LinkedList<String>();
		try {
			String[] acodecs = e.getAudioEncoders();
			for (int i = 0; i < acodecs.length; i++) {
				list.add(acodecs[i]);
			}
			YakiToOutput
					.message("Se ha obtenido la lista de codecs de audio disponibles ("
							+ acodecs.length + " codecs)");
		} catch (EncoderException ex) {
			YakiToOutput
					.error("No se ha podido obtener el listado de códecs de audio disponibles.");
		}
		return list;
	}

	/**
	 * Lista los codecs de video disponibles
	 * 
	 * @return Listado de codecs de video disponibles en YakiTo
	 */
	public static LinkedList<String> listAvailableVideoCodecs() {
		Encoder e = new Encoder();
		LinkedList<String> list = new LinkedList<String>();
		try {
			String[] vcodecs = e.getVideoEncoders();
			for (int i = 0; i < vcodecs.length; i++) {
				list.add(vcodecs[i]);
			}
			YakiToOutput
					.message("Se ha obtenido la lista de codecs de audio disponibles ("
							+ vcodecs.length + " codecs)");
		} catch (EncoderException ex) {
			YakiToOutput
					.error("No se ha podido obtener el listado de códecs de video disponibles.");
		}
		return list;
	}
}
